import { jsxs as t, jsx as e } from "react/jsx-runtime";

import { useState as o, useLayoutEffect as r, useMemo as n, useCallback as i, useEffect as s, useRef as l } from "react";

import { VirtualScrollerEvent as c, VirtualScroller as a } from "@af-utils/virtual-core";

import { useSyncExternalStore as h } from "use-sync-external-store/shim";

/**
 * @public
 * Map current visible items
 * @param model - {@link @af-utils/virtual-core#VirtualScroller} instance
 * @param cb - callback, returning ONLY ONE react element
 */ const f = (t, e) => {
    const o = [];
    for (let r = t.from, n = t.to; n > r; r++) o.push(e(r));
    return o;
}, d = (t, e) => {
    const o = [];
    for (let r = t.from, n = t.to, i = t.getOffset(r); n > r; r++, i += t.getSize(r)) o.push(e(r, i));
    return o;
}, u = {
    position: "relative",
    overflow: "hidden",
    contain: "strict",
    // otherwise may go above sticky header
    zIndex: -1
}, m = {
    ...u,
    height: "100%"
}, p = {
    ...u,
    width: "100%"
}, S = {
    position: "absolute",
    contain: "strict",
    overflow: "hidden",
    top: 0,
    left: 0
}, g = {
    ...S,
    display: "flex",
    height: "100%"
}, v = {
    ...S,
    display: "block",
    width: "100%"
}, y = t => {
    const [e, n] = o(null), [i, s] = o(null);
    return r((() => {
        if (t && e && i) {
            const o = () => {
                e.style[t.horizontal ? "width" : "height"] = t.scrollSize + "px";
            }, r = () => {
                const e = t.getOffset(t.from), o = t.getOffset(t.to);
                i.style.transform = `translate${t.horizontal ? "X" : "Y"}(${e}px)`, i.style[t.horizontal ? "width" : "height"] = o - e + "px";
            }, n = t.on(o, [ c.SCROLL_SIZE ]), s = t.on(r, [ c.RANGE, c.SIZES ]);
            return Object.assign(e.style, t.horizontal ? m : p), Object.assign(i.style, t.horizontal ? g : v), 
            o(), r(), () => {
                n(), s();
            };
        }
    }), [ t, e, i ]), [ n, s ];
};

/**
 * @public
 * Map current visible items and provide offset for each item.
 *
 * @remarks
 * Used in scenarios, when each item is absolutely positioned
 *
 * @param model - {@link @af-utils/virtual-core#VirtualScroller} instance
 * @param cb - callback, returning ONLY ONE react element
 */ function x(t) {
    switch (t) {
      case c.RANGE:
        return this.to ** 2 + this.from;

 // szudzik pair
              case c.SCROLL_SIZE:
        return this.scrollSize;

      default:
        return this.sizesHash;
    }
}

/**
 * @public
 * React hook.
 * Rerenders component when one of {@link @af-utils/virtual-core#(VirtualScrollerEvent:variable)} gets emitted.
 * Usually {@link Subscription} is a better alternative
 */ const z = (t, e) => {
    const [o, r] = n((() => [ o => t.on(o, e), () => e.map(x, t).join() ]), [ t, e ]);
    h(o, r, r);
}, w = t => (z(t.model, t.events), t.children()), E = ({model: o, children: r, itemData: n, component: s, header: l = null, footer: a = null, getKey: h = (t => t), tabIndex: d = -1, style: u, ...m}) => {
    const p = s || "div", [S, g] = y(o);
    return t(p, {
        ...m,
        style: {
            overflow: "auto",
            contain: "strict",
            ...u
        },
        ref: i((t => o.setScroller(t)), [ o ]),
        tabIndex: d,
        children: [ l, e("div", {
            ref: S,
            children: e("div", {
                ref: g,
                children: e(w, {
                    model: o,
                    events: [ c.RANGE ],
                    children: () => f(o, (t => e(r, {
                        model: o,
                        i: t,
                        data: n
                    }, h(t, n))))
                })
            })
        }), a ]
    });
}, I = process.env.__IS_SERVER__ ? s : r, O = (t, e) => I((() => (t.setScroller(e), 
() => t.setScroller(null))), [ t, e ])
/**
 * @public
 * React hook.
 * Allows to subscribe to {@link @af-utils/virtual-core#(VirtualScrollerEvent:variable)} without unnecessary rerenders.
 *
 * @remarks
 * For example can be used in load-on-demand.
 *
 * @param model - {@link @af-utils/virtual-core#VirtualScroller} instance
 * @param events - array of {@link @af-utils/virtual-core#VirtualScrollerEvent} to subscribe
 * @param callBack - callback to be called
 */ , R = (t, e, o) => s((() => {
    if (o) return o(), t.on(o, e);
}), [ t, o, e ])
/**
 * @public
 * React hook.
 * Creates and stores one {@link @af-utils/virtual-core#VirtualScroller} instance.
 * It does not get recreated during component lifecycle.
 * Normally {@link useVirtual} should be used.
 * @param params - {@link @af-utils/virtual-core#VirtualScrollerInitialParams}
 * @returns same {@link @af-utils/virtual-core#VirtualScroller} instance
 */ , _ = t => l().current ||= new a(t)
/**
 * @public
 * React hook.
 * Calls {@link useVirtualModel} and synchronizes it with props
 * @param params - {@link @af-utils/virtual-core#VirtualScrollerInitialParams}
 * @returns same {@link @af-utils/virtual-core#VirtualScroller} instance
 */ , b = t => {
    const e = _(t);
    return I((() => e.set(t))), e;
};

/**
 * @public
 * React component.
 * {@link SubscriptionProps}.
 * Rerenders only on certain {@link @af-utils/virtual-core#(VirtualScrollerEvent:variable)}.
 * Allows to optimize performance.
 */ export { E as List, w as Subscription, f as mapVisibleRange, d as mapVisibleRangeWithOffset, z as useComponentSubscription, O as useScroller, R as useSubscription, y as useSyncedStyles, b as useVirtual, _ as useVirtualModel };
//# sourceMappingURL=index.js.map
